
#include "instructions.h"
using namespace std;


    LoopInstruction::LoopInstruction()
    {
    }

    LoopInstruction::~LoopInstruction()
    {
    }




    LoopProgram::LoopProgram()
    {
    }

    LoopProgram::~LoopProgram()
    {
        for(vector<LoopInstruction*>::iterator i = Instructions.begin(); i != Instructions.end(); i++)
            delete *i;
    }

    void LoopProgram::Execute(ExecutionContext* context)
    {
        for(vector<LoopInstruction*>::iterator i = Instructions.begin(); i != Instructions.end(); i++)
            (*i)->Execute(context);
    }





    LoopConstLoop::LoopConstLoop(int IterCount, LoopProgram* Block)
        : LoopInstruction()
    {
        this->IterCount = IterCount;
        this->Block = Block;
    }

    LoopConstLoop::~LoopConstLoop()
    {
        delete Block;
    }

    void LoopConstLoop::Execute(ExecutionContext* context)
    {
        for(int i = 0; i < IterCount; i++)
            Block->Execute(context);
    }





    LoopVarLoop::LoopVarLoop(string IterVar, LoopProgram* Block)
        : LoopInstruction()
    {
        this->IterVar = IterVar;
        this->Block = Block;
    }

    LoopVarLoop::~LoopVarLoop()
    {
        delete Block;
    }

    void LoopVarLoop::Execute(ExecutionContext* context)
    {
        int i = 0;
        if(context->Variables.find(IterVar) != context->Variables.end())
            i = context->Variables[IterVar];
        for(; i > 0; --i)
            Block->Execute(context);
    }





    Assignment::Assignment(string DstVariable, string SrcVariable, int Added)
        : LoopInstruction()
    {
        this->DstVariable = DstVariable;
        this->SrcVariable = SrcVariable;
        this->Added = Added;
    }

    Assignment::~Assignment()
    {
    }

    void Assignment::Execute(ExecutionContext* context)
    {
        int tmp = 0;
        if(context->Variables.find(SrcVariable) != context->Variables.end())
            tmp = context->Variables[SrcVariable];
        context->Variables[DstVariable] = tmp + Added;
    }

